/* WidgetUtils.c generated by valac 0.18.0, the Vala compiler
 * generated from WidgetUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    For copyright information, see AUTHORS.

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <libnotify/notify.h>
#include <common.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DEJA_DUP_TYPE_SHELL_ENV (deja_dup_shell_env_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;

typedef enum  {
	DEJA_DUP_SHELL_ENV_NONE,
	DEJA_DUP_SHELL_ENV_GNOME,
	DEJA_DUP_SHELL_ENV_UNITY,
	DEJA_DUP_SHELL_ENV_LEGACY
} DejaDupShellEnv;

struct _Block4Data {
	int _ref_count_;
	GtkWidget* w;
};


extern DejaDupShellEnv deja_dup_shell;
DejaDupShellEnv deja_dup_shell = DEJA_DUP_SHELL_ENV_NONE;

void deja_dup_show_uri (GtkWindow* parent, const gchar* link);
void deja_dup_destroy_widget (GtkWidget* w);
GType deja_dup_shell_env_get_type (void) G_GNUC_CONST;
DejaDupShellEnv deja_dup_get_shell (void);
gboolean deja_dup_user_focused (GtkWidget* win, GdkEventFocus* e);
static gboolean _deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self);
void deja_dup_show_background_window_for_shell (GtkWindow* win);
void deja_dup_hide_background_window_for_shell (GtkWindow* win);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda2_ (Block4Data* _data4_);
static gboolean ___lambda2__gsource_func (gpointer self);
gboolean deja_dup_gui_initialize (GtkWindow* parent, gboolean show_error);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void deja_dup_show_uri (GtkWindow* parent, const gchar* link) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (parent != NULL);
	g_return_if_fail (link != NULL);
	{
		GtkWindow* _tmp0_;
		GdkScreen* _tmp1_ = NULL;
		GdkScreen* _tmp2_;
		GdkScreen* screen;
		const gchar* _tmp3_;
		guint32 _tmp4_ = 0U;
		_tmp0_ = parent;
		_tmp1_ = gtk_window_get_screen (_tmp0_);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		screen = _tmp2_;
		_tmp3_ = link;
		_tmp4_ = gtk_get_current_event_time ();
		gtk_show_uri (screen, _tmp3_, _tmp4_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (screen);
			goto __catch5_g_error;
		}
		_g_object_unref0 (screen);
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GtkWindow* _tmp5_;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_;
		GtkMessageDialog* _tmp8_;
		GtkMessageDialog* dlg;
		GtkMessageDialog* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		GtkMessageDialog* _tmp12_;
		GtkMessageDialog* _tmp13_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = parent;
		_tmp6_ = _ ("Could not display %s");
		_tmp7_ = link;
		_tmp8_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp5_, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _tmp6_, _tmp7_);
		g_object_ref_sink (_tmp8_);
		dlg = _tmp8_;
		_tmp9_ = dlg;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		gtk_message_dialog_format_secondary_text (_tmp9_, "%s", _tmp11_);
		_tmp12_ = dlg;
		gtk_dialog_run ((GtkDialog*) _tmp12_);
		_tmp13_ = dlg;
		deja_dup_destroy_widget ((GtkWidget*) _tmp13_);
		_g_object_unref0 (dlg);
		_g_error_free0 (e);
	}
	__finally5:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


GType deja_dup_shell_env_get_type (void) {
	static volatile gsize deja_dup_shell_env_type_id__volatile = 0;
	if (g_once_init_enter (&deja_dup_shell_env_type_id__volatile)) {
		static const GEnumValue values[] = {{DEJA_DUP_SHELL_ENV_NONE, "DEJA_DUP_SHELL_ENV_NONE", "none"}, {DEJA_DUP_SHELL_ENV_GNOME, "DEJA_DUP_SHELL_ENV_GNOME", "gnome"}, {DEJA_DUP_SHELL_ENV_UNITY, "DEJA_DUP_SHELL_ENV_UNITY", "unity"}, {DEJA_DUP_SHELL_ENV_LEGACY, "DEJA_DUP_SHELL_ENV_LEGACY", "legacy"}, {0, NULL, NULL}};
		GType deja_dup_shell_env_type_id;
		deja_dup_shell_env_type_id = g_enum_register_static ("DejaDupShellEnv", values);
		g_once_init_leave (&deja_dup_shell_env_type_id__volatile, deja_dup_shell_env_type_id);
	}
	return deja_dup_shell_env_type_id__volatile;
}


DejaDupShellEnv deja_dup_get_shell (void) {
	DejaDupShellEnv result = 0;
	DejaDupShellEnv _tmp0_;
	DejaDupShellEnv _tmp10_;
	_tmp0_ = deja_dup_shell;
	if (_tmp0_ == DEJA_DUP_SHELL_ENV_NONE) {
		{
			GList* _tmp1_ = NULL;
			GList* caps;
			gboolean persistence;
			gboolean actions;
			GList* _tmp2_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean _tmp9_;
			_tmp1_ = notify_get_server_caps ();
			caps = _tmp1_;
			persistence = FALSE;
			actions = FALSE;
			_tmp2_ = caps;
			{
				GList* cap_collection = NULL;
				GList* cap_it = NULL;
				cap_collection = _tmp2_;
				for (cap_it = cap_collection; cap_it != NULL; cap_it = cap_it->next) {
					gchar* _tmp3_;
					gchar* cap = NULL;
					_tmp3_ = g_strdup ((const gchar*) cap_it->data);
					cap = _tmp3_;
					{
						const gchar* _tmp4_;
						_tmp4_ = cap;
						if (g_strcmp0 (_tmp4_, "persistence") == 0) {
							persistence = TRUE;
						} else {
							const gchar* _tmp5_;
							_tmp5_ = cap;
							if (g_strcmp0 (_tmp5_, "actions") == 0) {
								actions = TRUE;
							}
						}
						_g_free0 (cap);
					}
				}
			}
			_tmp7_ = persistence;
			if (_tmp7_) {
				gboolean _tmp8_;
				_tmp8_ = actions;
				_tmp6_ = _tmp8_;
			} else {
				_tmp6_ = FALSE;
			}
			_tmp9_ = _tmp6_;
			if (_tmp9_) {
				deja_dup_shell = DEJA_DUP_SHELL_ENV_GNOME;
			} else {
				deja_dup_shell = DEJA_DUP_SHELL_ENV_LEGACY;
			}
		}
	}
	_tmp10_ = deja_dup_shell;
	result = _tmp10_;
	return result;
}


static gboolean _deja_dup_user_focused_gtk_widget_focus_in_event (GtkWidget* _sender, GdkEventFocus* event, gpointer self) {
	gboolean result;
	result = deja_dup_user_focused (_sender, event);
	return result;
}


gboolean deja_dup_user_focused (GtkWidget* win, GdkEventFocus* e) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	guint _tmp2_ = 0U;
	g_return_val_if_fail (win != NULL, FALSE);
	g_return_val_if_fail (e != NULL, FALSE);
	_tmp0_ = win;
	gtk_window_set_urgency_hint (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_WINDOW, GtkWindow), FALSE);
	_tmp1_ = win;
	g_signal_parse_name ("focus-in-event", GTK_TYPE_WIDGET, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
	result = FALSE;
	return result;
}


void deja_dup_show_background_window_for_shell (GtkWindow* win) {
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* _tmp2_;
	DejaDupShellEnv _tmp3_ = 0;
	g_return_if_fail (win != NULL);
	_tmp0_ = win;
	gtk_window_set_focus_on_map (_tmp0_, FALSE);
	_tmp1_ = win;
	gtk_window_set_urgency_hint (_tmp1_, TRUE);
	_tmp2_ = win;
	g_signal_connect ((GtkWidget*) _tmp2_, "focus-in-event", (GCallback) _deja_dup_user_focused_gtk_widget_focus_in_event, NULL);
	_tmp3_ = deja_dup_get_shell ();
	if (_tmp3_ == DEJA_DUP_SHELL_ENV_UNITY) {
		GtkWindow* _tmp4_;
		GtkWindow* _tmp5_;
		GtkWindow* _tmp6_;
		_tmp4_ = win;
		gtk_window_iconify (_tmp4_);
		_tmp5_ = win;
		gtk_widget_show ((GtkWidget*) _tmp5_);
		_tmp6_ = win;
		gtk_window_iconify (_tmp6_);
	} else {
		GtkWindow* _tmp7_;
		_tmp7_ = win;
		gtk_widget_show ((GtkWidget*) _tmp7_);
	}
}


void deja_dup_hide_background_window_for_shell (GtkWindow* win) {
	DejaDupShellEnv _tmp0_ = 0;
	g_return_if_fail (win != NULL);
	_tmp0_ = deja_dup_get_shell ();
	if (_tmp0_ == DEJA_DUP_SHELL_ENV_UNITY) {
		GtkWindow* _tmp1_;
		GtkWindow* _tmp2_;
		GtkWindow* _tmp3_;
		_tmp1_ = win;
		gtk_window_iconify (_tmp1_);
		_tmp2_ = win;
		gtk_widget_show ((GtkWidget*) _tmp2_);
		_tmp3_ = win;
		gtk_window_iconify (_tmp3_);
	} else {
		GtkWindow* _tmp4_;
		_tmp4_ = win;
		gtk_widget_hide ((GtkWidget*) _tmp4_);
	}
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}


static void block4_data_unref (void * _userdata_) {
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		_g_object_unref0 (_data4_->w);
		g_slice_free (Block4Data, _data4_);
	}
}


static gboolean __lambda2_ (Block4Data* _data4_) {
	gboolean result = FALSE;
	GtkWidget* _tmp0_;
	_tmp0_ = _data4_->w;
	gtk_widget_destroy (_tmp0_);
	result = FALSE;
	return result;
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ (self);
	return result;
}


void deja_dup_destroy_widget (GtkWidget* w) {
	Block4Data* _data4_;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	g_return_if_fail (w != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_tmp0_ = w;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data4_->w);
	_data4_->w = _tmp1_;
	_tmp2_ = _data4_->w;
	gtk_widget_hide (_tmp2_);
	_tmp3_ = _data4_->w;
	g_object_ref ((GObject*) _tmp3_);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda2__gsource_func, block4_data_ref (_data4_), block4_data_unref);
	block4_data_unref (_data4_);
	_data4_ = NULL;
}


gboolean deja_dup_gui_initialize (GtkWindow* parent, gboolean show_error) {
	gboolean result = FALSE;
	gchar* header = NULL;
	gchar* msg = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean rv;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	gboolean _tmp6_;
	_tmp2_ = deja_dup_initialize (&_tmp0_, &_tmp1_);
	_g_free0 (header);
	header = _tmp0_;
	_g_free0 (msg);
	msg = _tmp1_;
	rv = _tmp2_;
	_tmp4_ = rv;
	if (!_tmp4_) {
		gboolean _tmp5_;
		_tmp5_ = show_error;
		_tmp3_ = _tmp5_;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp6_ = _tmp3_;
	if (_tmp6_) {
		GtkWindow* _tmp7_;
		const gchar* _tmp8_;
		GtkMessageDialog* _tmp9_;
		GtkMessageDialog* dlg;
		GtkMessageDialog* _tmp10_;
		const gchar* _tmp11_;
		GtkMessageDialog* _tmp12_;
		GtkMessageDialog* _tmp13_;
		_tmp7_ = parent;
		_tmp8_ = header;
		_tmp9_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp7_, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "%s", _tmp8_);
		g_object_ref_sink (_tmp9_);
		dlg = _tmp9_;
		_tmp10_ = dlg;
		_tmp11_ = msg;
		gtk_message_dialog_format_secondary_text (_tmp10_, "%s", _tmp11_);
		_tmp12_ = dlg;
		gtk_dialog_run ((GtkDialog*) _tmp12_);
		_tmp13_ = dlg;
		deja_dup_destroy_widget ((GtkWidget*) _tmp13_);
		_g_object_unref0 (dlg);
	}
	result = rv;
	_g_free0 (msg);
	_g_free0 (header);
	return result;
}



